package JaRPE;

import java.awt.*;
import java.awt.event.*;
import JaRPE.*;
import JaRPE.Javins.*;
import java.io.*;



public class ButtonJavins extends BaseJavins implements ActionListener{

    Button b = new Button("ON");
    PipedOutputStream pop;
    PipedInputStream  pip;
    boolean value = true;

    public ButtonJavins() {
        super();
        add(b);
        b.setFont(new Font("Helvetica", Font.BOLD, 12));
        b.setForeground(Color.red);
        b.addActionListener(this);
        try {
            pop = new PipedOutputStream();
            pip = new PipedInputStream(pop);
        }catch (Exception e) {
            e.printStackTrace();
        }

        setLocalSignalSource(this);
    }


    public SignalPair getLocalSignalPair() {

        SignalPair sp= new SignalPair();
                   sp.signalIn = new DataInputStream(pip);
                   sp.signalOut= null;
        return sp;
    }

    public void readSignal(SignalInputStream mySignalIn) throws IOException{
            if (mySignalIn.readByte() != 0) {
                b.setForeground(Color.red);
                b.setLabel("ON");
                value = true;
            }
            else {
              b.setLabel("OFF");
              b.setForeground(Color.green);
              value = false;
            }
    }

    public boolean writeSignal2Server(DataOutputStream signalOut) throws IOException{
            if (value) signalOut.writeByte(1);
            else signalOut.writeByte(0);
        return true;
    }

    public void readSignalFServer(DataInputStream signalIn) throws IOException{
       byte readValue;
            readValue = signalIn.readByte();
            if (readValue == 1) {
                pop.write(0);
                pop.flush();
            }
            else if (readValue == 2) {
                pop.write(1);
                pop.flush();
            }
   }

    public static void main (String args[]) {
        ButtonJavins bj = new ButtonJavins();
        Frame f = new Frame(bj.getComponentName() + " -> Test <-");
        f.setLayout(new BorderLayout());
        f.add(bj);
        f.setSize(bj.getSize().width, bj.getSize().height);
        f.pack();
        f.show();
        Thread t = new Thread(bj);
        System.runFinalizersOnExit(true);
        new WindowCloser(f, true);
        bj.setServerPort(3000);
        bj.setServer(true);
        bj.initializeConections();
        bj.conected = true;
        bj.run();


    }

    public void actionPerformed(ActionEvent e) {
    try{
        value = !value;
        if (value){
                pop.write(1);
                pop.flush();
        }
        else {
              pop.write(0);
              pop.flush();
        }
    }catch (Exception ex) {
        ex.printStackTrace();
    }
   }

}