package JaRPE.Javins;

import java.awt.*;
import java.awt.event.*;
import JaRPE.*;
import JaRPE.Javins.*;
import java.io.*;



public class JaviMultiPos extends BaseJavins implements ActionListener, Serializable, Runnable{

    MultiInterface b;
    boolean value = true;
    private String labelItems = "Sinus.,Triung.,Drept.";
    private boolean newValue = false;
    private byte    valueByte= 1;

    transient PipedOutputStream pop;
    transient PipedInputStream  pip;

    transient ActionListener actionListener;
    String    actionCommand;



    public JaviMultiPos() {
        super();
        setComponentName("JaviMultiPos");
        b = new MultiInterface();
        add(b);
        enableEvents(AWTEvent.ACTION_EVENT_MASK);
        b.setFont(new Font("Helvetica", Font.BOLD, 12));
        b.setForeground(Color.red);
        b.addActionListener(this);
        try {
            pop = new PipedOutputStream();
            pip = new PipedInputStream(pop);
        }catch (Exception e) {
            e.printStackTrace();
        }

    }

    public void setLabelItems(String labelItems) {
        this.labelItems = labelItems;
        b.setElements(labelItems);
    }

    public String getLabelItems() {
        return this.labelItems;
    }

    public SignalPair getLocalSignalPair() {

        SignalPair sp= new SignalPair();
                   sp.signalIn = new DataInputStream(pip);
                   sp.signalOut= null;
        return sp;
    }


    public void  readSignal(SignalInputStream mySignalIn) throws IOException{
        byte readValue = mySignalIn.readByte();
        if ( readValue != 0 ) {
            b.setCurrent(readValue -1);
            ActionEvent ne = new ActionEvent(this, 1, readValue-1 + "");
            processActionEvent(ne);
        }
    }

    public boolean  writeSignal(DataOutputStream myDataOut) throws IOException{
            if (getLocalSignalSource() == null) {
            if (newValue) {
                    int byteValue = pip.read();
                    myDataOut.writeByte((byte)byteValue);
                    synchronized(this) {
                        newValue = false;
                    }
                    return true;
            } else {
                    myDataOut.writeByte(0);
                    return true;
            }
        }
        else if (newValue) {
                    myDataOut.writeByte(valueByte);
                    synchronized(this) {
                        newValue = false;
                    }
        }
        else myDataOut.writeByte(0);
        return true;
    }

    public boolean  writeSignal2Server(DataOutputStream signalOut) throws IOException{
        signalOut.writeByte(b.getCurrent()+1);
        return true;
    }

    public void  readSignalFServer(DataInputStream signalIn)  throws IOException{
       int readValue;
       readValue = signalIn.readByte();
       if (readValue != 0) {
            pop.write(readValue);
            valueByte = (byte)readValue;
            pop.flush();
            newValue = true;
            communicate("new remote value");
       }
    }

    private void writeObject (ObjectOutputStream oos) throws IOException{
        oos.defaultWriteObject();
    }

    private void readObject (ObjectInputStream ois) throws IOException, ClassNotFoundException {
        ois.defaultReadObject();
        localSignalSourceClass = "";
        try {
            pop = new PipedOutputStream();
            pip = new PipedInputStream(pop);
        }catch (Exception e) {
            e.printStackTrace();
        }
    }


    public static void main (String args[]) {
        JaviMultiPos bj = new JaviMultiPos();
        bj.setLabelItems("Lili,Remus,Restul");
        Frame f = new Frame(bj.getComponentName() + " -> Test <-");
        f.setLayout(new BorderLayout());
        f.add(bj);
        f.setSize(bj.getSize().width, bj.getSize().height);
        f.pack();
        f.show();
        Thread t = new Thread(bj);
        System.runFinalizersOnExit(true);
        new WindowCloser(f, true);
        bj.setSourcePort(3004);
        bj.setSourceURL("localhost");
        bj.initializeConections();
        bj.conected = true;
        bj.run();
    }

    public synchronized void addActionListener(ActionListener l) {
    	actionListener = AWTEventMulticaster.add(actionListener, l);
    }

    public synchronized void removeActionListener(ActionListener l) {
	actionListener = AWTEventMulticaster.remove(actionListener, l);
    }

    protected void processEvent(AWTEvent e) {
        if (e instanceof ActionEvent) {
            processActionEvent((ActionEvent)e);
            return;
        }
	super.processEvent(e);
    }

    protected void processActionEvent(ActionEvent e) {
        if (actionListener != null) {
            actionListener.actionPerformed(e);
        }
    }

    public void setActionCommand(String command) {
        actionCommand = command;
    }

    public String getActionCommand() {
        return actionCommand;
    }

    protected String paramString() {
	    return super.paramString();
    }


    public void actionPerformed(ActionEvent e) {
    try{
        synchronized(this) {
                   newValue = true;
                   valueByte = (byte)(b.getCurrent() + 1);
        }
        pop.write(valueByte);
        pop.flush();
    }catch (Exception ex) {
        ex.printStackTrace();
    }

   }
}
