package JaRPE.Javins;

import java.io.Serializable ;


public class Modifier implements Serializable {
    protected Modifier modif;

    public Modifier() {
        this.modif = null;
    }

    public Modifier(Modifier modif) {
        this.modif = modif;
    }

    public Modifier (String modifClassName) {
     try{
        Class modifClass = Class.forName(modifClassName);
        this.modif = (Modifier)modifClass.newInstance();
     } catch (ClassNotFoundException ex) {
        System.err.println("Modifier Class : " +  modifClassName +
                           " not found !");
        ex.printStackTrace();
        this.modif = null;
        System.err.println("Modifier initializet to NULL");

     } catch (Exception ex) {
        System.err.println("Sorry cant instantiate Modifier Class: " +
                            modifClassName );
        ex.printStackTrace();
        this.modif = null;
        System.err.println("Modifier initializet to NULL");
       }
    }

    public void setModifier(Modifier modif) {
        this.modif = modif;
    }

    public Modifier getModifier() {
        return this.modif;
    }

    public boolean modifyBoolean(boolean b) {
        return b;
    }

    public byte modifyByte(byte b) {
        return b;
    }

    public int modifyInt(int b) {
        return b;
    }

    public short modifyShort(short b) {
        return b;
    }

    public char modifyChar(char b) {
        return b;
    }

    public long modifyLong(long b) {
        return b;
    }

    public float modifyFloat(float  b) {
        return b;
    }

    public double modifyDouble(double b) {
        return b;
    }

    public String modifyString(String b) {
        return b;
    }
}
