/**********************************************************************************
 * ClassName  :   SignalModifier
 * Date       :   17, Mai  1998
 * Autor      :   Remus Pereni [RP]
 * Description:   Vezi mai jos
 **********************************************************************************/

package JaRPE.Javins;

import java.io.DataInputStream;

/**
* RemoteSignalSource - implementeaza o interfata comuna pentru toate
* Javinsurile care pot prelua un semnal de la un server de semnal
* prin internet sau intranet
*
* @author   Remus Pereni
* @version  0.01, 17 May 1998 01:30 AM
*/

public interface SignalModifier {

    String   signalModifierClass = "";
    Modifier signalModifier      = null;

    public void setSignalModifierClass (String signalModiferClass);

    public String getSignalModifierClass ();

    public void setSignalModifier (Modifier signalModifer);

    public Modifier getSignalModifier ();

    public void instantiateSignalModifierClass();

    public SignalInputStream modifySignal(SignalPair signalPair);

}
