/**********************************************************************************
 * ClassName  :   SignalPair
 * Date       :   17, Mai  1998
 * Autor      :   Remus Pereni [RP]
 * Description:   Vezi mai jos
 **********************************************************************************/

package JaRPE.Javins;

import java.io.DataInputStream;
import java.io.DataOutputStream;

/**
* SignalPair asigura tratarea unitara a unei surse de semnal.
* S-a pornit de la idea ca fiecare Javins lucreaza cu o sursa de semnal
* iar acea sursa de semnal trebuie sa asigure comunicarea in ambele
* sensuri. Acesta comunicatie se realizeaza prin intermediul acestor
* sreamuri.
*
* @author   Remus Pereni
* @version  0.01, 17 Mai 1998 01:30 AM
*/
public class SignalPair {
    /**
    * signalIn - este streamul care asigura datele de intrare
    */
    public DataInputStream  signalIn;

    /**
    * signalIn - este streamul care asigura iesirea datelor
    */
    public DataOutputStream signalOut;
}