package JaRPE;

import java.net.*;
import java.io.*;
import java.awt.*;
import java.util.Vector;
import java.lang.reflect.*;
import JaRPE.Javins.*;


public class SmartPanel extends Panel {
    private Vector    javinst;
    private SmartProp interfaceSmartProp;
    private Panel workp = new Panel();

    public SmartPanel(Vector components) {
        super();
        this.javinst = components;
        JavinstWrapper jwr = (JavinstWrapper)javinst.elementAt(0);
        interfaceSmartProp = (SmartProp)jwr.getJavinstObject();
        setLayout(null);
        setBounds(0,0, interfaceSmartProp.getInterfaceWidth()
                           , interfaceSmartProp.getInterfaceHeight());
        setBackground(interfaceSmartProp.getInterfaceBackground());
        setForeground(interfaceSmartProp.getInterfaceForeground());
        setFont(interfaceSmartProp.getInterfaceFont());

        for (int i = 1; i< components.size(); i++) {
            jwr = (JavinstWrapper)javinst.elementAt(i);
            Component com = (Component)jwr.getJavinstObject();
            add(com);
            if (com instanceof Runnable ) {
                System.out.println("E runable");
             if (com instanceof BaseJavins) {
                        System.out.println("Startimg thread for class: " + com.getClass().getName());
                        Thread runthread = new Thread((Runnable)com);
                        runthread.start();
             }
             else {
                Method met[] = com.getClass().getDeclaredMethods();
                for (int j = 0; j < met.length ; j++){
                    if (met[j].getName().equals("run") || com instanceof BaseJavins) {
                        System.out.println("Startimg thread for class: " + com.getClass().getName());
                        Thread runthread = new Thread((Runnable)com);
                        runthread.start();
                     }
                }
             }
            }

            paint(getGraphics());
        }
   }
}