package JaRPE.JaRPEdit;

import java.beans.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.awt.Toolkit.*;
import java.io.*;
import java.util.Vector;
import JaRPE.*;


class ComponentBox extends Frame {
    private ComponentBoxPanel panel;
    private JaRPEdit parent;

    ComponentBox(JaRPEdit parent, int x, int y) {
	super();
	this.parent = parent;
	setLayout(new GridLayout(1,1));
	setBackground(SystemColor.control);
	setCursor(Cursor.HAND_CURSOR);
	setFont(new Font("Dialog", Font.PLAIN, 10));
  	setIconImage(getToolkit().getImage("images/tool32.gif"));
	panel = new ComponentBoxPanel(parent, this);
	add(panel);
	panel.setLocation(0,0);
	setLocation(x, y);
	setSize(55, 390);
	show();
    }

    Vector getLoadedJarInfo() {
    	return panel.getLoadedJarInfo();
    }

    void addBeansInJar(String jarFile) {
    	panel.addBeansInJar(jarFile);
    	panel.refreshComponents();
    }
}

