
package JaRPE.Javins;


import java.awt.*;
import java.io.*;

public class Diagram extends Canvas {
    private boolean grid;
    private boolean draw;
    private Dimension dim;
    private int x, y;
    Graphics gr;        // double buffering
    Image offScreenBuffer;
    BufferedReader instr;


    public Diagram () {
        super();
        setBackground(Color.black);
    }

    public void setGrid(boolean grd) {
        grid = grd;
        paint(getGraphics());
    }

    public void draw(int y) {
            this.y = y;
            update(getGraphics());
    }

    public void update(Graphics g) {
     if ( g != null) {
        dim = getSize();
        g.setColor(Color.green.brighter());
        g.drawLine(x, dim.height/2 - y, x, dim.height/2 - y);
        x++;
        if (x>=dim.width) {
            x= 0;
            paint(g);
        }
     }
   }


   public void paint(Graphics g) {
    if (g != null) {
     dim = getSize();
     g.setColor(Color.darkGray);
     g.clearRect(0, 0, dim.width, dim.height);
     if (grid) {
        for( int i = 0; i< dim.width; i+=10)
              g.drawLine(i, 0, i, dim.height);
        for (int j = 0; j< dim.height;j+=10)
              g.drawLine(0, j, dim.width, j);
     }
    }
   }

}
