
package JaRPE.Javins;

import java.net.*;
import java.io.*;
import java.lang.Thread;

public class JavinsDispecher implements Serializable, Runnable{

    protected BaseJavins        baseJavins;
    protected transient ServerSocket      serverSocket;
    protected transient Socket            socket;
    protected transient DataInputStream   rDataIn;
    protected transient DataOutputStream  rDataOut;


    public JavinsDispecher(BaseJavins baseJavins) {
        this.baseJavins = baseJavins;
        createServer();
    }

    public void createServer() {
        System.out.println("Creating server !");
        try {
            serverSocket= new ServerSocket(baseJavins.getServerPort());
        }catch (Exception ex) {
            ex.printStackTrace();
            System.out.println("in creareServer");
        }
    }

    public void stopServer() {

    }


    public void run() {
      while(true) {
        System.out.println("Waiting for clients");
        try {
             socket   = serverSocket.accept();
             System.out.println("I have clients");
             baseJavins.communicate("New Client:" + socket.getInetAddress().getHostAddress());
             rDataIn  = new DataInputStream(socket.getInputStream());
             rDataOut=  new DataOutputStream(socket.getOutputStream());
             for ( ; ;) {
                    (Thread.currentThread()).yield();
                    baseJavins.writeSignal2Server(rDataOut);
                    baseJavins.readSignalFServer(rDataIn);
             }
        }catch (SocketException ex) {
             System.out.println("Client lost !");
              baseJavins.communicate("Client Lost");

        }
         catch (Exception ex) {
             System.out.println("Client lost !");
        }
      }
    }
}


