
package JaRPE;

import java.awt.*;
import java.awt.event.*;
/**
 *Permite afisarea facila a unui mesaj sub forma grafica
 */
public class Message extends Dialog {

    /**
     * Constructorul clasei
     *@param parent Frame-ul parinte din care se lanseaza mesajul (necesar pt pozitionare)
     *@param type   Mesajul care va aparea ca title
     *@param mess   Mesajul afisat
     */
    public Message (Frame parent, String type, String mess) {
        super(parent, type);
        setModal(true);
        Label  l1   = new Label("                                                  ", 1);
        Label  l2   = new Label("                                                  ", 1);
        Label  l3   = new Label("                                                  ", 1);
        Panel  p1   = new Panel();
        Panel  p2   = new Panel();
        Panel  p3   = new Panel();
        Button b_ok = new Button("     Ok     ");
        Gadge  g    = new Gadge();
        setBackground(SystemColor.control);
        setLayout(new BorderLayout(5, 5));
        addWindowListener(new myWList());
        b_ok.addActionListener(new myAList());
        l1.setForeground(Color.black);
        l2.setForeground(Color.black);
        l3.setForeground(Color.black);
        p2.setLayout(new BorderLayout(5, 5));
        p1.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
        p3.setLayout(new GridLayout(3,1));
        p3.add(l1);
        p3.add(l2);
        p3.add(l3);
        p2.add("Center", p3);
        p1.add(b_ok);
        p2.add("South", p1);
        add("West", g);
        add("Center",p2);
        setSize(400, 100);
        if ( mess.length() > 100) {
            l3.setText(mess.substring(100));
            l2.setText(mess.substring(50, 100));
            l1.setText(mess.substring(1 , 50));
        }
        else if ( mess.length() < 100 && mess.length() > 50 ) {
            l2.setText(mess.substring(50));
            l1.setText(mess.substring(1 , 50));
          }
         else l2.setText(mess);
        move(parent.getLocation().x + 50, parent.getLocation().y + 50 );
        show();
        g.repaint();
    }

    class myWList implements WindowListener{

   		public void windowClosing(WindowEvent e) {
          dispose();
    	}
        public void windowActivated(WindowEvent   e) { ;}
		public void windowClosed(WindowEvent      e) { ;}
		public void windowDeactivated(WindowEvent e) { ;}
		public void windowDeiconified(WindowEvent e) { ;}
	 	public void windowIconified(WindowEvent   e) { ;}
	    public void windowOpened(WindowEvent      e) { ;}
    }

    class myAList implements ActionListener {

    	public void actionPerformed( ActionEvent e) {
          dispose();

        }
    }

    class Gadge extends Canvas {
        Gadge () {
            setSize(50, 100);
            setBackground(Color.red);

        }

        public void paint(Graphics g) {
            Dimension dim = getSize();
            setForeground(Color.blue);
            g.fillRect(dim.width/4 , dim.height/8, dim.width/2, dim.height/2);
            g.fillOval((int) ( dim.width/4),
            		   (int) ( dim.height/4 + dim.height/2),
                       (int) ( dim.width/2),
                       (int) ( dim.height/8));

        }
    }
    /**
     * Numai pentru teste
     */
    public static void main( String args[] ) {
    Frame f = new Frame();
    Message m= new Message (f, "Error!" , "Salut baieti ce mai faceti");
    }


}


