
import java.applet.Applet;
import java.net.*;
import java.io.*;
import java.awt.*;
import java.util.Vector;
import JaRPE.*;

public class SmartApplet extends Applet {
    private SmartPanel smartPanel;
    private Vector comp;
    SmartProp obj ;

    public void init() {
        loadJavinst(getCodeBase().toString() + getParameter("InterfaceFile"));
        setLayout(new BorderLayout());
        smartPanel = new SmartPanel(comp);
        add("Center", smartPanel);
        add("North",new Label(obj.getInterfaceTitle(), Label.CENTER));

    }


    private void loadJavinst(String location) {
     try{
         URL where = new URL(location);
         ObjectInputStream ois = new ObjectInputStream(where.openStream());
         int dim = ois.readInt();
         comp = new Vector(dim);
         for (int j = 0; j < dim; j++) {
            JavinstWrapper wrp = (JavinstWrapper) ois.readObject();
            comp.addElement(wrp);
         }
         JavinstWrapper wr = (JavinstWrapper) comp.elementAt(0);
         obj = (SmartProp)wr.getJavinstObject();
         setBounds(0,0,obj.getInterfaceWidth()+10, obj.getInterfaceHeight()+10);
         setSize(obj.getInterfaceWidth()+10, obj.getInterfaceHeight()+10);
      }  catch(Exception e){
            e.printStackTrace();
     }
    }

}
