package JaRPE;

import java.io.*;
import java.beans.*;
import java.awt.*;


public class SmartPanelProp extends Container implements Serializable{
    private Container content;
    private SmartProp smartp;

    public SmartPanelProp() {
        super();
        smartp = new SmartProp();
    }

    public SmartPanelProp(Container cont) {
        super();
        smartp = new SmartProp();
        this.content = cont;
        if (content != null) {
            smartp.setInterfaceLocationX((content.getBounds()).x);
            smartp.setInterfaceLocationY((content.getBounds()).y);
            smartp.setInterfaceHeight((content.getBounds()).height);
            smartp.setInterfaceWidth((content.getBounds()).width);
        }
    }

    public SmartPanelProp(Container cont, SmartProp smp) {
        super();
        smartp = smp;
        this.content = cont;
        if (content != null) {
            smartp.setInterfaceLocationX((content.getBounds()).x);
            smartp.setInterfaceLocationY((content.getBounds()).y);
            smartp.setInterfaceHeight((content.getBounds()).height);
            smartp.setInterfaceWidth((content.getBounds()).width);
        }
    }

    public SmartProp getSmartProp() {
        return this.smartp;
    }

    public void setSmartProp(SmartProp smp) {
        //smartp = smp;
        setInterfaceTitle(smp.getInterfaceTitle());
        setInterfaceBackground(smp.getInterfaceBackground());
        setInterfaceForeground(smp.getInterfaceForeground());
        setInterfaceFont(smp.getInterfaceFont());
        smartp.setInterfaceLocationX(smp.getInterfaceLocationX());
        smartp.setInterfaceLocationY(smp.getInterfaceLocationY());
        smartp.setInterfaceWidth(smp.getInterfaceWidth());
        smartp.setInterfaceHeight(smp.getInterfaceHeight());
        setInterfaceWidth(smp.getInterfaceWidth());
    }
    public synchronized void setInterfaceTitle(String title) {
        smartp.setInterfaceTitle(title);
        if (content != null && content instanceof Frame) ;
                ((Frame)content).setTitle(smartp.getInterfaceTitle());
    }
    public String getInterfaceTitle() {
        return smartp.getInterfaceTitle();
    }
    public synchronized void setInterfaceFont(Font font) {
        smartp.setInterfaceFont(font);
        if (content != null) {
            content.setFont(font);
            content.repaint();
        }
    }
    public Font getInterfaceFont() {
        return smartp.getInterfaceFont();
    }

    public synchronized void setInterfaceBackground(Color background) {
        smartp.setInterfaceBackground(background);
        if (content != null) {
            content.setBackground(background);
            content.repaint();
        }
    }

    public Color getInterfaceBackground() {
        return smartp.getInterfaceBackground();
    }

    public synchronized void setInterfaceForeground(Color foreground) {
        smartp.setInterfaceForeground(foreground);
        if (content != null) {
            content.setForeground(foreground);
            content.repaint();
        }
    }

    public Color getInterfaceForeground() {
        return smartp.getInterfaceForeground();
    }

    public synchronized void setInterfaceWidth(int width) {
        smartp.setInterfaceWidth(width);
        if (content != null) {
            content.setBounds( smartp.getInterfaceLocationX()
                              ,smartp.getInterfaceLocationY()
                              ,smartp.getInterfaceWidth()
                              ,smartp.getInterfaceHeight());
        }
    }

    public int getInterfaceWidth() {
        if (content != null) {
               smartp.setInterfaceWidth((content.getBounds()).width);
               smartp.setInterfaceHeight((content.getBounds()).height);
               smartp.setInterfaceLocationX((content.getBounds()).x);
               smartp.setInterfaceLocationY((content.getBounds()).y);
        }
        return smartp.getInterfaceWidth();
    }

    public synchronized void setInterfaceHeight(int height) {
        smartp.setInterfaceHeight(height);
        if (content != null) {
            content.setBounds( smartp.getInterfaceLocationX()
                              ,smartp.getInterfaceLocationY()
                              ,smartp.getInterfaceWidth()
                              ,smartp.getInterfaceHeight());
        }
    }

    public int getInterfaceHeight() {
        if (content != null) {
               smartp.setInterfaceWidth((content.getBounds()).width);
               smartp.setInterfaceHeight((content.getBounds()).height);
               smartp.setInterfaceLocationX((content.getBounds()).x);
               smartp.setInterfaceLocationY((content.getBounds()).y);
        }
        return smartp.getInterfaceHeight();
    }

}