
import java.applet.Applet;
import java.net.*;	      	   
import java.io.*;
import java.awt.*;
import java.util.Vector;
import JaRPE.*;

public class SmartApplet extends Applet {
    private SmartPanel smartPanel;
    private Vector comp;
    private String  remoteTargetLocation;
    private boolean file;
    SmartProp obj ;

    public SmartApplet() {
    }

    public SmartApplet(String remoteTargetLocation) {
        this.remoteTargetLocation = remoteTargetLocation;
        this.file = true;
    }

    public void init() {
        loadJavinst();
        setLayout(new BorderLayout());
        smartPanel = new SmartPanel(comp);
        add("Center", smartPanel);
        add("North",new Label(obj.getInterfaceTitle(), Label.CENTER));

    }

    public void setRemoteTargetLocation(String targloc) {
        this.remoteTargetLocation = targloc;
    }

    private void loadJavinst() {
     try{
         ObjectInputStream ois;
         if (!file) {
                remoteTargetLocation = getCodeBase().toString() + getParameter("InterfaceFile");
                URL where = new URL(remoteTargetLocation);
                ois = new ObjectInputStream(where.openStream());
         }
         else {
                File where = new File(remoteTargetLocation);
                ois = new ObjectInputStream(new FileInputStream(where));
         }
         int dim = ois.readInt();
         comp = new Vector(dim);
         for (int j = 0; j < dim; j++) {
            JavinstWrapper wrp = (JavinstWrapper) ois.readObject();
            comp.addElement(wrp);
         }
         JavinstWrapper wr = (JavinstWrapper) comp.elementAt(0);
         obj = (SmartProp)wr.getJavinstObject();
         setBounds(0,0,obj.getInterfaceWidth()+10, obj.getInterfaceHeight()+10);
         resize(new Dimension(obj.getInterfaceWidth()+10, obj.getInterfaceHeight()+10));
      }  catch(Exception e){
            e.printStackTrace();
     }
    }
public static void main (String args[]) {
    Frame mainf = new Frame("Remote Process Interface");
    SmartApplet app = new SmartApplet("./" + args[0]);
    mainf.add(app);
    app.init();
    app.repaint();
    mainf.setBounds(0,0,640, 400);
    mainf.setVisible(true);
    new WindowCloser(mainf, true);
}
  //acesta este numai un test  cu Emacs
}
